// CPU_UsageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CPU_Usage.h"
#include "CPU_UsageDlg.h"
#include "windows.h"
#include "Tlhelp32.h"
#include "Afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCPU_UsageDlg dialog

CCPU_UsageDlg::CCPU_UsageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCPU_UsageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCPU_UsageDlg)
	m_cpu = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCPU_UsageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCPU_UsageDlg)
	DDX_Text(pDX, IDC_EDIT1, m_cpu);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCPU_UsageDlg, CDialog)
	//{{AFX_MSG_MAP(CCPU_UsageDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCPU_UsageDlg message handlers

BOOL CCPU_UsageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
	SumThreadTimes();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

int CCPU_UsageDlg::SumThreadTimes() 
{ 
	HANDLE hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0); 
	
	int newKernel=0;
	int oldKernel=0;
	int newUser=0;
	int oldUser=0;
	int newTime=0;
	int oldTime=0;
	int CPU_Usage=0;

    THREADENTRY32 entry; 
    entry.dwSize = sizeof(THREADENTRY32); 
        
    Thread32First(hSnapShot, &entry); 
             
	FILETIME creation, exit, kernel, user; 
    do 
    { 
      if(GetThreadTimes( (HANDLE) entry.th32ThreadID , &creation, &exit, &kernel, &user)==0) 
	  { 
  	    AfxMessageBox (_T("Can't get thread time!"));
      } 
      else
	  {
		oldKernel=newKernel;
		oldUser=newUser;
		oldTime=newTime;
		newKernel += kernel.dwLowDateTime;
		newUser += user.dwLowDateTime;
		newTime += creation.dwLowDateTime;
			
		entry.dwSize = sizeof(THREADENTRY32); 
					
		CPU_Usage=100*(newKernel-oldKernel+newUser-oldUser)/(newTime-oldTime);

		this->m_cpu.Format(_T("%d"), CPU_Usage);
		UpdateData(false);

		AfxMessageBox (_T("Success"));
	  } 
	    Sleep(3000);

    } while( Thread32Next(hSnapShot, &entry) );
 
	  CloseToolhelp32Snapshot(hSnapShot); 
} 

